//need to straighten head

#ifndef INCLUDED_BoxStep3_h_
#define INCLUDED_BoxStep3_h_
#include "Behaviors/BehaviorBase.h" //necessary for all behavior
#include "SoundPlay/SoundManager.h" //necessary for any sound
#include "Motion/MotionManager.h" //for motions
#include "Motion/PostureMC.h" //unneccesary for this example
#include "Motion/WalkMC.h" //definition of the basic walk
#include "Shared/WorldState.h" //for state pointer
#include "Motion/MMAccessor.h" //to access active motions
#include "Shared/SharedObject.h" //always with motion
#include "Events/EventRouter.h" //for event handling (always)
#define IROORDist 900 //maximum 210 range (mm)
#define IRMinDist 600 //let's call this the minimum (mm)(was 300)

class BoxStep3 : public BehaviorBase {
public:
BoxStep3():BehaviorBase(),HBtn(EventBase::buttonEGID,HeadButOffset,EventBase::activateETID)
{
//do nothing
}

~BoxStep3()
{
//if somehow were still running when this runs, we should be sure to turn it off
if(isActive())
DoStop();
}

// DoStart is typically where the setup logic / motion initializations occur
virtual void DoStart() {
//call superclass first for housekeeping:
cout<<"start";
	BehaviorBase::DoStart();
walk_count = 0;
walk_id=motman->addPrunableMotion(SharedObject<WalkMC>());
//erouter->addListener(this,EventBase::buttonEGID); // subscribes to all sensor events
erouter->addListener(this,EventBase::motmanEGID,walk_id,EventBase::deactivateETID);//watch for end of walk
        MMAccessor<WalkMC> walk(walk_id);
		walk.mc()->setTargetVelocity(150,0,0,15);
		cout<<walk_count;

} //end DoStart

virtual void DoStop() {
motman->removeMotion(walk_id); //remove the WalkMC motion tied to walk_id
//erouter->forgetListener(this); // stops getting events (and timers, if we had any)
erouter->removeListener(this);
BehaviorBase::DoStop(); // run base class for consistency / cleanup
}


/*virtual void processEvent(const EventBase& event) {
        MMAccessor<WalkMC> walk(walk_id);
		walk.mc()->setTargetVelocity(150,0,0,15);
		walk_count++;
		cout<<walk_count;
		//while (walk.mc()->isDirty())
		//{}
		//walk.mc()->setTargetVelocity(0,150,0,15);
	}
*/
	virtual void processEvent(const EventBase& /*e*/) {
		erouter->removeListener(this);
		if (walk_count <=5){
			walk_id=motman->addPrunableMotion(SharedObject<WalkMC>());

			MMAccessor<WalkMC> walk(walk_id);

		walk.mc()->setTargetVelocity(150,walk_count,0,15);

		erouter->addListener(this,EventBase::motmanEGID,walk_id,EventBase::deactivateETID);
		walk_count++;
		cout<<walk_count;
		}
	}
//return an approriate string representing the name. This too, is neccessary.
virtual std::string getName() const { return "BoxStep3"; }
protected:
	int walk_count;
	EventBase HBtn;
MotionManager::MC_ID walk_id; //create an MC_ID for my walk
}; //end class
#endif