//-*-c++-*-
#ifndef INCLUDED_SampleSoundBehavior_h_
#define INCLUDED_SampleSoundBehavior_h_
#include "Behaviors/BehaviorBase.h"
#include "SoundPlay/SoundManager.h"
#include "Shared/ERS7Info.h"

class SampleSoundBehavior : public BehaviorBase {

public:  
	SampleSoundBehavior() : BehaviorBase("SampleSoundBehavior"),curplay(SoundManager::invalid_Play_ID), endtime(0) {}    
	virtual void DoStart() {
		BehaviorBase::DoStart();
		std::cout<<"Sound Start!";
		sndman->LoadFile("Bose_R2P.wav");
		play("Bose_R2P.wav");
	
	}  
	virtual void DoStop() {BehaviorBase::DoStop();
		sndman->ReleaseFile("Bose_R2P.wav");
		std::cout<<"Sound End!";
	}
protected:
	//! called when a button is pressed - checks if it should enqueue or just play
	void play(const char* name) {
		if(!state->buttons[ChinButOffset]) {

			// Just play the sound
			// This is probably all you need how to do unless you want to get fancy
			sndman->PlayFile(name);

		} else {

			// Enqueue the sound - mainly useful if you have a set of sounds and want to play a song with them
			if(curplay==SoundManager::invalid_Play_ID || !pauseWhileChin && get_time()>=endtime) {
				//start a new chain, either this is the first or we already finished playing the chain
				curplay=sndman->PlayFile(name);
				if(pauseWhileChin)
					sndman->PausePlay(curplay);
			} else //add to existing chain
				sndman->ChainFile(curplay,name);
			endtime=sndman->GetRemainTime(curplay)+get_time()-SoundBufferTime;
			//-SoundBufferTime to guarrantee ID validity, see SoundManager::GetRemainTime() documentation

		}
	}
	static const bool pauseWhileChin=true; //!< if this is true, won't start playing chain until you release the chin button
	SoundManager::Play_ID curplay; //!< current chain (may not be valid if chin button not down or time is past #endtime)
	unsigned int endtime; //!< the expected end of play time for the current chain
	
	//!@name Event Templates
	//!Used to match against the different buttons that have sounds mapped to them
	EventBase LFr,RFr,LBk,RBk,Back;
	//@}
};


#endif
