//-*-c++-*-
#ifndef INCLUDED_SimpleSoccer_h_
#define INCLUDED_SimpleSoccer_h_

#include "Behaviors/BehaviorBase.h"
#include "Motion/MotionManager.h"
#include "Behaviors/Controls/FileBrowserControl.h"
#include "Motion/MotionSequenceMC.h"
#include "Motion/EmergencyStopMC.h"
#include "Motion/LedMC.h"
#include "SoundPlay/SoundManager.h"
#include "Motion/MMAccessor.h"
#include "Shared/TimeET.h"
#include "Shared/Config.h"
#include <string>

const int GOALIE_ID = 0; //const Goalie
const int ATTACKER_ID = 10;//conts Attacker Drop Chest
const int ATTACKER_ID2 = 11;//conts Attacker Head Butt
const float GOALIE_DESIRED_AREA = 0.03491717; //const Goalie
const float ATTACKER_DESIRED_AREA = 0.02091717;//conts Attacker
const float ATTACKER_DESIRED_AREA2 = 0.02491717;//conts Attacker

const int PLAY_PAUSED = 1;
const int PLAY_PLAY = 0;


//! A simple behavior to chase after any objects seen by the vision system
class SimpleSoccer : public BehaviorBase {
public:
	//!constructor
	SimpleSoccer()
		: BehaviorBase("SimpleSoccer"), headpointer_id(MotionManager::invalid_MC_ID), walker_id(MotionManager::invalid_MC_ID), HBtn(EventBase::buttonEGID,HeadButOffset,EventBase::activateETID)
	{
			sndman->PlayFile("SoccerPr.wav");
	}
	//!destructor
	virtual ~SimpleSoccer() {}

	//! adds a headpointer and a walker, and a listens for vision events
	virtual void DoStart();

	//! removes motion commands and stops listening
	virtual void DoStop();

	//! sets the head to point at the object and sets the body to move where the head points
	virtual void processEvent(const EventBase& event);
			
	static std::string getClassDescription() { return "Follows ball with head and walks whereever the head is pointing"; }
	virtual std::string getDescription() const { return getClassDescription(); }

protected:
	int player_type;	//PlayerType
	float previous_area; //previous Area
	float desired_area;
	int play_mode;
	EventBase HBtn;
	MotionManager::MC_ID headpointer_id; //!< a HeadPointerMC object
	MotionManager::MC_ID walker_id;      //!< a WalkMC object
};

/*! @file
 * @brief Describes SimpleSoccer, which runs around after whatever the dog sees
 * @author ejt (Creator)
 *
 * $Author: ejt $
 * $Name: tekkotsu-2_3 $
 * $Revision: 1.5 $
 * $State: Exp $
 * $Date: 2004/11/11 01:45:35 $
 */

#endif
