//need to straighten head

#ifndef INCLUDED_BoxStep2_h_
#define INCLUDED_BoxStep2_h_
#include "Behaviors/BehaviorBase.h" //necessary for all behavior
#include "SoundPlay/SoundManager.h" //necessary for any sound
#include "Motion/MotionManager.h" //for motions
#include "Motion/PostureMC.h" //unneccesary for this example
#include "Motion/WalkMC.h" //definition of the basic walk
#include "Shared/WorldState.h" //for state pointer
#include "Motion/MMAccessor.h" //to access active motions
#include "Shared/SharedObject.h" //always with motion
#include "Events/EventRouter.h" //for event handling (always)
#define IROORDist 900 //maximum 210 range (mm)
#define IRMinDist 600 //let's call this the minimum (mm)(was 300)

class BoxStep2 : public BehaviorBase {
public:

BoxStep2():BehaviorBase(),HBtn(EventBase::buttonEGID,HeadButOffset,EventBase::activateETID)
{
//do nothing
}

~BoxStep2()
{
//if somehow were still running when this runs, we should be sure to turn it off
if(isActive())
DoStop();
}

// DoStart is typically where the setup logic / motion initializations occur
virtual void DoStart() {
//call superclass first for housekeeping:
BehaviorBase::DoStart();
HBbtn_count = 0;

walk_id=motman->addMotion(SharedObject<WalkMC>());

erouter->addListener(this,EventBase::buttonEGID); // subscribes to all sensor events
erouter->addTimer(this,0,1000,true);
} //end DoStart

virtual void DoStop() {
motman->removeMotion(walk_id); //remove the WalkMC motion tied to walk_id
erouter->forgetListener(this); // stops getting events (and timers, if we had any)
BehaviorBase::DoStop(); // run base class for consistency / cleanup
}

virtual void processEvent(const EventBase& event) {
	if (event==HBtn){
		timer_counter = 0;
	}

	if(event.getGeneratorID()==EventBase::timerEGID) {
		timer_counter++;
	}

	int x;
	int y;
	int z;	
	if (timer_counter <=5){
			x=150.0;
			y=0;
			z=0;
	}
	else
	{
		if (timer_counter <=10){
			x=0;
			y=150.0;
			z=0;
		}
		else
		{	if (timer_counter <=15){
			x=-150.0;
			y=0;
			z=0;
			}
			else
			{
				if (timer_counter <=20){
				x=0;
				y=-150.0;
				z=0;
				}
				else
				{
					x=0;
					y=0;
					z=0;
				}
			}
		}
	}

    MMAccessor<WalkMC> walk(walk_id);
	int rSteps;
	cout<<"walk ahead 15"<<endl;
	walk.mc()->setTargetVelocity(x,y,z,15);
	rSteps = walk.mc()->getRemainingSteps();
	cout << " rSteps: " << rSteps;

}
//return an approriate string representing the name. This too, is neccessary.
virtual std::string getName() const { return "BoxStep2"; }
protected:
	int HBbtn_count;
	int timer_counter;
	EventBase HBtn;
MotionManager::MC_ID walk_id; //create an MC_ID for my walk
}; //end class
#endif