#include "SimpleAttacker.h"
#include "Events/EventRouter.h"
#include "Events/VisionObjectEvent.h"
#include "Shared/WorldState.h"
#include "Motion/HeadPointerMC.h"
#include "Motion/WalkMC.h"
#include "Shared/WMclass.h"
#include "Shared/ProjectInterface.h"

//! Converts degrees to radians
//inline double DtoR(double deg) { return (deg/180.0*M_PI); }

void SimpleAttacker::DoStart() {
	//PlayerType
	//const Goalie
	//conts Attacker
	//previous Area
	previous_area=999;

	BehaviorBase::DoStart();
	headpointer_id = motman->addPersistentMotion(SharedObject<HeadPointerMC>());
	walker_id = motman->addPersistentMotion(SharedObject<WalkMC>());
	erouter->addListener(this,EventBase::visObjEGID,ProjectInterface::visPinkBallSID);
}

void SimpleAttacker::DoStop() {
	erouter->removeListener(this);
	motman->removeMotion(headpointer_id);
	motman->removeMotion(walker_id);
	BehaviorBase::DoStop();
}

//this could be cleaned up event-wise (only use a timer when out of view)
void SimpleAttacker::processEvent(const EventBase& event) {
	if (event.getSourceID()==ProjectInterface::visPinkBallSID)
	{

		WMreg(chase_ball_behavior);
		WMvari_(float, horiz, 0, chase_ball_behavior);
		WMvari_(float, vert, 0, chase_ball_behavior);
		WMvari_(float, area, 0, chase_ball_behavior);

		if(event.getGeneratorID()==EventBase::visObjEGID && event.getTypeID()==EventBase::statusETID) {
			horiz=static_cast<const VisionObjectEvent*>(&event)->getCenterX();
			vert=static_cast<const VisionObjectEvent*>(&event)->getCenterY();
			area=static_cast<const VisionObjectEvent*>(&event)->getArea ();
		}
		
		//cout << "Area: " <<  area << endl;

		WalkMC * walker = (WalkMC*)motman->checkoutMotion(walker_id);
		
		if ((area > 0.01491717)||(previous_area==999)||(area >= previous_area)){
			cout << "Area: " <<  area << endl;
			cout << "Previous Area: " <<  previous_area << endl;
			previous_area = area;
			if(state->outputs[HeadOffset+PanOffset]<-.05 || state->outputs[HeadOffset+PanOffset]>.05)
				walker->setTargetVelocity(100,0,state->outputs[HeadOffset+PanOffset]);
			else
				walker->setTargetVelocity(160,0,0);
			motman->checkinMotion(walker_id);
			  
			//		cout << inview << ' ' << horiz << ' ' << vert << endl;
			/*shoot
-0.2307692112032
0.725962

Farther
-0.5288462112032
0.677885

Area: Right on top 0.00591717*/

			double tilt=state->outputs[HeadOffset+TiltOffset]-vert*M_PI/7.5;
			double pan=state->outputs[HeadOffset+PanOffset]-horiz*M_PI/6;
			if(tilt<DtoR(-20))
				tilt=DtoR(-20);
			if(tilt>DtoR(40))
				tilt=DtoR(40);
			if(pan>DtoR(80))
				pan=DtoR(80);
			if(pan<DtoR(-80))
				pan=DtoR(-80);
			HeadPointerMC * headpointer= (HeadPointerMC*)motman->checkoutMotion(headpointer_id);
			headpointer->setJoints(tilt,pan,0);
			motman->checkinMotion(headpointer_id);
		}
		else {
			if (previous_area != 1000){
				walker->setTargetVelocity(0,0,0);
				motman->checkinMotion(walker_id);
				cout << "KICK!" << endl;
				
				SharedObject<MediumMotionSequenceMC>  s("/ms/data/motion/gu_front.mot");
				//cout << "Load Time: " << timer.Age() << endl;
				motman->addPrunableMotion(s);
				previous_area=1000;
			}
			else {
				cout << "RESET!" << endl;
				previous_area=999;
			}
		}
	}
}			



